/*	
    csci4211 Spring 2006
    Programming Project 1: Messenger with P2P File Sharing System
    Maker Name:Nagapramod Mandagere 
    Student ID:
    email address:npramod@cs.umn.edu
    gcc -lsocket -lnsl peer.c sockcomm.c -o peer*/

#include "peer.h"

int main(int argc, char *argv[])
{
  
  if(argc!=2 && argc!=3)
    {
      printf("Usage: %s <directory name> [<peer name>]\n", argv[0]);
      exit(0);
    }

  /* argv[1] contains the pathname of the directory that is shared */
  strcpy(szDir,argv[1]);
  ret_val = strlen(szDir);

  if(szDir[ret_val-1] != '/')
    strcat(szDir, "/"); //let szDir have '/' at the end

  if((dp=opendir(szDir))==NULL)
    {
      printf("Can not open directory '%s'\n", szDir);
      exit(0);
    }
  else
    {
      filelist[0]='\0';
      filelist_size = 0;

      printf("############################\n");
      printf("### List of Shared Files ###\n");
      printf("############################\n");
      i = 1;
      while((dirp=readdir(dp))!=NULL)
	{
	  if((strcmp(dirp->d_name,".")==0) || (strcmp(dirp->d_name,"..")==0)) continue;
	  strcat(filelist,dirp->d_name);
	  strcat(filelist,"\r\n");
	  strcpy(filelist_entry[filelist_size++], dirp->d_name);
	  printf("%d. %s\n", i++, dirp->d_name);
	}
      closedir(dp);
    }
  printf("############################\n");




  /* start accepting join request of new peers */
  if((hJoinSock=SocketInit(JOIN_PORT))==-1)
    {	  	
      perror("SocketInit");
      exit(1); 
    }

  
  /* Step 1: get the complete DNS name of this host machine using appropriate socket functions*/
  
 gethostname(myDnsName,100);

  /* Step 2: use the DNS name obtained in previous set to get the host entry structure using approriate socket functions*/
 
 myhostent = gethostbyname(myDnsName);


  /* store this host's IP address in myhost_ipaddr */
  memcpy(&myhost_ipaddr, *(myhostent->h_addr_list),sizeof(struct in_addr));
  
  myhost_addr.sin_addr.s_addr = inet_addr(inet_ntoa(*(struct in_addr *)*myhostent->h_addr_list));
  printf("admin: Peer started on %s on port %d\n",inet_ntoa(*(struct in_addr *)*myhostent->h_addr_list),JOIN_PORT);
  
  if(argc>2)
    {
      /*Step 3: Connect to the known peer(specified as argument) using Join method*/
       sock = join(argv[2], JOIN_PORT);




      if(sock==-1)
	{
	  perror("main(): join() error!\n");
	  exit(1);
	}
      /* Step 4: Update peerlist and peerNames arrays*/
      peerlist[0] = sock;
      peerlist_size++;

      
      strcpy(peerNames[0],argv[2]);
      peerNames_size++;

    }

  printf("\n*** Help: To see the commands, type \"help\" ***\n");
  
   
 
  
  /* Step 5: Prepare parameters for Select() call , initialize stdin, livesdset and livesdmax */
  /*    Note: 'sock' is not set for the first member since it doesn't join others */
 



  /* Step 6: Add all peer scokets to livesdset for select to monitor */
  
  FD_ZERO(&livesdset);
  FD_SET(0, &livesdset);
  FD_SET(hJoinSock,&livesdset);
  for(i = 0; i < peerlist_size; i++)
    FD_SET(peerlist[i],&livesdset);
  

  while(1)
    {
      int frsock;
      
      /* Step 7: Copy livesdset into readset  */
      
      memcpy(&readset, &livesdset, sizeof(fd_set));
      /* print prompt */
      printf("\n[peer:%s] ", myDnsName);
      /* Step 8: Call select system call with appropriate parameters */
      	if(select(FD_SETSIZE, &readset, NULL, NULL, NULL) == -1)
    	{
      	perror("select:killing here");
      	exit(1);
    	}
      
      
      
      /* join request on hJoinSock from a new peer */
      if(FD_ISSET(hJoinSock,&readset))
    	{
	  /*
	    Step 9:  Accept connection request for new joining peer host.
	    Step 10: Update 'livesdset' and 'livesdmax'
	    Step 11: Get the joining peer's name using appropriate socket functions
	  */
	  int newsock;
	  newsock = AcceptConnection(hJoinSock);
	  FD_SET(newsock,&livesdset);
	  peerlen = sizeof(peer_sin);
	  getpeername(newsock,&peer_sin,&peerlen);
	  
	  /*Step 12: Get peer host's full DNS name */
	  
	  peerEntry = gethostbyaddr((char *)&peer_sin.sin_addr.s_addr, sizeof(peer_sin.sin_addr.s_addr), AF_INET);


	  strcpy(peerDnsName,peerEntry->h_name);
	  token = strtok(peerDnsName,".");
	  printf("%s has logged in",token);
	       
	

	  /* Step 13: Update peerNames and peerList arrays */
	  
	  
	  strcpy(peerNames[peerNames_size],token);
	  peerNames_size++;
	  peerlist[peerlist_size] = newsock;
	  peerlist_size++;

	}//end if for joinrequests

	
	
	
      /* check lookup requests from neighboring peers */
      for(i = 0; i < peerlist_size; i++)
    	{
	  int d;
	  frsock = peerlist[i];
	  /* 
	     frsock starts from 3 since descriptor 0, 1 and 2 are
	     stdin, stdout and stderr
	  */
	  if(FD_ISSET(frsock,&readset))
	    {
	      /* Step 14: Read message from socket 'frsock' */
	      
	      ReadMsg(frsock,&msg,sizeof(msg));
     
           
		
	      if(strlen(msg) == 0)
		{
		  
		  peerlen = sizeof(peer_sin);
		  getpeername(frsock,&peer_sin,&peerlen);
		  
		 
		  FD_CLR(frsock,&livesdset);		
		  livesdmax--;
		  
		  /* Step 15: get the DNS name of disconnected peer and extract the host name for display*/
		  peerEntry = gethostbyaddr((char *)&peer_sin.sin_addr.s_addr, sizeof(peer_sin.sin_addr.s_addr), AF_INET);
		  strcpy(peerDnsName,peerEntry->h_name);
		  token = strtok(peerDnsName,".");
		  printf("%s has logged out",token);
		  

		  /* Step 16: update peerlist and peerNames array */
		 
		  for(d=i;d<peerlist_size-1;d++)
		    peerlist[d] = peerlist[d+1];
		  peerlist_size--;
		  
		  for(d=i;d<peerNames_size - 1;d++)
		    strcpy(peerNames[d],peerNames[d+1]);
		  peerNames_size--;
			
			
		}
	      
	      


	      /* If message size is >0, inspect whehter it is a 'GET' message */
	      
	      if(strlen(msg) > 0)
		{
		  strcpy(msg_temp,msg);
		  
		 
		  token1 = strtok(msg, " \t\n");
		  if(strcasecmp(token1, "get")==0)	
		    {
		      
		      /* Extract file name, IP address and port number in the 'GET' message */
		      token = strtok(NULL, " \t\n"); //remove cr character, namely carriage return
		      if(token != NULL)
			strcpy(filename, token);
			token = strtok(NULL," \t\n"); //remove cr character, namely carriage return
      			if(token != NULL)
			  strcpy(peer_ipaddr_buf, token);
			token = strtok(NULL," \t\n"); //remove cr character, namely carriage return
      			if(token != NULL)
			  strcpy(peer_port_buf, token);

	
			/* print the message in stdout */
        		printf("%s:%s has requested a file \"%s\".\n", peer_ipaddr_buf, peer_port_buf, filename);

			/* local lookup on 'filelist' to check whether requested file is in this peerhost */
			flag = FALSE;
			for(i = 0; i < filelist_size; i++)
			  {
			    if(strcmp(filename, filelist_entry[i]) == 0)
			      {
          			flag = TRUE;
				break;
			      } 
			  }
			/* If requested file presents, make connection to originating host and send data */
			if(flag == TRUE)
			  {
			    
			   
			    int sd1;
			    int temp_port = atoi(peer_port_buf);
			    FILE *fp;
			    char path[100];

			    /* Step 17:  Open the requested File*/
			    

			    /* Step 18: Setup the socket and its parameters*/
			    
			    
			    if(connect(sd1, (struct sockaddr*)&addr1, sizeof(addr1))!=-1)
			      {
				/* Step 19: Read the file using file handle obtained earlier and write it to the socket created */
				



			      }
			    
			  }	
			
			else
			  {
			    /* Step 20: If requested file is not here, forward 'GET' message to all neighbors except the requester */
			   

			  }
			
		    }//get message			
		  
		 
		  else
		    {
		      /* Step 21: Has to be a chat message, if message is a broadcast, print it to stdout in appropriate format
			 and send the message to all peers but for the one message was received from, 
			 else just print to stdout in appropriate format */
		      
		      
		      chatMsg = strtok(NULL,"\t");
		      msgSender = strtok(NULL,"\t");
			 
		      
		      if(strcmp(token1,"broadcast")==0)
			{
			  
			  
			  for(m = 0;m<peerlist_size;m++)
			    if(peerlist[m] != frsock)
			      {
				SendMsg(peerlist[m],&msg_temp,sizeof(msg_temp));			
				
			      }
			}
		      printf("\n%s->%s\n",msgSender,chatMsg);
		    }
		 
		}//message > 0
	      
	    } //end of if for peer requests
	} //end of for
      

      /* For loop to check for activity on sockets connected to child processes */
      int c,s;
      for(c = 0;c<socklist_size;c++)
	{	
	  frsock = socklist[c];
	  
	  
	  if(FD_ISSET(frsock,&readset))
	    {	
	      
	      /* Step 22: Read message from socket */
	      
	      
	      if(ret_val == -1) //if-2
        	{
		  perror("main(): ReadMsg() error!\n");
		  continue;
        	} //end of if-2
	      
	      int x1= atoi(msg);
	      
	      
	    
	      if(x1)
		{
		  if((dp=opendir(szDir))==NULL)
		    {
		      printf("Can not open directory '%s'\n", szDir);
		      exit(0);
		    }
		  else
		    {
		      /* Step 23: Print the contents of shared directory (hint: same code is used elsewhere in the program) */






		    }
		  printf("############################\n");
		  printf("Requested File has been copied to the local share\n");
			
	 	}
	      else printf("Sorry:Requested File was not found on the Peer Network\n");
	      
	      /* Step 24: Clear the socket from livesdset and update socklist array*/
	      


	      close(frsock);
	      
	    }
	}
      



      if(FD_ISSET(0,&readset))
    	{
	  if(!fgets(szBuffer,MAXMSGLEN,stdin)) exit(0);
	  
    
	  
	  /*  Inspect whether input command is a valid 'get' command with file name */
	  token = strtok(szBuffer, " \t\n");
	  if(token == NULL) //process NULL character if user pushes enter key
	    continue;
	  
	  if(strcasecmp(token, "files") == 0)
	    {
	      printf("### List of Shared Files ###\n");
	      for(i = 0; i < filelist_size; i++)
          	printf("%d. %s\n", i + 1, filelist_entry[i]);
	      continue;
	    }
	  
	  else if(strcasecmp(token, "list") == 0)
	    {
	      printf("### Friends List ###\n");
	      for(i = 0; i < peerNames_size; i++)
		printf("%d. %s\n",i + 1,peerNames[i]);
	      continue;
	    }
	  else if(strcasecmp(token, "IM") == 0)
	    {


	      /* Step 25: Extract the destination host name and the chat message
		 
	      Construct a message with - destination name/"broadcast", chat message and the sender's name
	      If it is a broadcast message, send it to everybody, else find the corresponding entry in 
	      peerNames and peerlist and send it to correct destination
	      */
	       
	      token = strtok(NULL," ");
	      if(token != NULL)
		strcpy(msgDest,token);
	      else
		{
		  printf("Not a valid Dest\n");
		  continue;
		}
	      strcpy(chat,msgDest);
	      strcat(chat,"\t");
	      token = strtok(NULL, " ");
	      if(token != NULL)
		strcat(chat, token);
	      else
		{
		  printf("Message Format wrong\n");
		  continue;
		}

	      myName = strtok(myDnsName,".");
	      strcat(chat,"\t");
	      strcat(chat,myName);
	      if(strcmp(msgDest,"broadcast")==0)
		{
		  for(m = 0;m<peerlist_size;m++)
		    SendMsg(peerlist[m],&chat,sizeof(chat));
		  continue;
		}
	      else
		{
		  for(i = 0; i < peerNames_size; i++)
		    if(strcmp(msgDest,peerNames[i]) == 0)break;
		  if(i == peerNames_size) 
		    {
		      printf("Peer not found\n");
		      continue;
		    }
		  else
		    {
		      
		      SendMsg(peerlist[i],&chat,sizeof(chat));
		      continue;
		    }
		  
		}
	      
	      
	    }
	  
	  else if(strcasecmp(token, "help") == 0)
	    {
	      print_manual();
	      continue;
	    }
	  
	  else if(strcasecmp(token, "quit") == 0)
	    {
	      exit(0);
	    }
	  
	  else if(strcasecmp(token, "get") != 0)
	    {
	      printf("The input command is invalid!\n");
	      continue;   
	    }
	  
	  /* Extracting file name */
	  token = strtok(NULL, " \t\n"); //remove cr character, namely carriage return
	  if(token != NULL)
	    strcpy(filename, token);
	  else
	    {
	      printf("main(): there is no file name in 'get' command!\n");
	      continue;
	    }
	  
	  /* check if the requested file is already in its shared directory.
	     if so, skip the following sequence for getting the file p2p tree.
	  */
	  flag = FALSE;
	  /*Step 26: Check if requested file is already in its shared directory
	    if so, display appropriate message and skip peer enquiry - Set flag = TRUE
	  */
	  



	  
	  /* check if there are more than one peer */
	  if(flag == FALSE)
	    {
	      if(peerlist_size == 0) //if there is no neighor, skip the following sequence to send a query message
		{
		  flag = TRUE; 
		  printf("Because the requested file \"%s\" is not in the local shared directory  \"%s\" and there is no peer, you cannot get the file.\n", filename, szDir);
		}
	    }
	  
	  if(flag != TRUE)// enquire peer to peer tree
      		{
		  /* Step 27 : Create a pair of sockets for the communication between parent process and child process
		     sockfd[0] is the socket of parent process, and sockfd[1] is the socket of child process
		   */
		  

		
		 		
		  

		  FD_SET(sockfd[0],&livesdset);
		  socklist[socklist_size] = sockfd[0];
		  socklist_size++;
		  /* Step 28: Create new listen socket for future data channel setup - use a unique port */
		  

		  
	
		  
		  
		  /* fork() to generate a child process */
		  pid = fork();
		  if(pid == -1) //if
		    {
		      perror("main(): fork() error!\n");
		    } //end of if
		  else if(pid == 0) //else if-pid 
		    {
		      // From here, the child process performs the codes from here.
		      
		      int count = 0; //variable for counting the number of the senders of the requested file.
		      /* if(count > 1) then send  "UPDATE-ACK" to its parent process
			 else send "UPDATE-NAK" to its parent process
		      */
		      /* Step 29: In the child process, use select() to monitor listen socket. Set a timout
			 period for the select(). If no connection after timeout, close the listen
			 socket.
		      */
		      
		
			
			if(FD_ISSET(hListenSock,&readset2))
			  {
			    /* Step 30: AcceptConnection() from sender and receive the file and update count accordingly */
			    
			   
			  }
			
			if(count == 0) //if
			  {
			    strcpy(msg, "UPDATE-NAK");
			    /* Step 31: Send appropriate message to parent process */
			   
          		} //end of if
			
			
			if(count !=0)
			  {
			    strcpy(msg, "UPDATE-ACK!!!!!!!!!!");
			    /* Step 32: Send appropriate message to parent process */
			   
			  }	
			
			close(hListenSock);
          		close(sockfd[1]); //close the child's socket
          		exit(0); //terminate the child process in order to allow other peers' connect to return
		    } //end of else if-pid 
		  
		  else
		    {
		      
		      /* Step 33: In the parent process, construct "GET" message and send it to all neighbor peers. */
		      
		      
		      
		      
		      
		      close(sockfd[1]); //close the child's socket
		      
		           
		    }// end of else
		  
		}
    	}// if for keyboard
      
    }// end of while
}//end of main

